Skip to content

Create a command type

POST
/command-types
curl --request POST \
--url https://example.com/api/v1/command-types \
--header 'Content-Type: application/json' \
--data '{ "description": "example", "display_name": "example", "name": "example", "params_schema": "example", "settle_window_seconds": 1, "target_property_type": "example" }'

Registers a custom command type (official=false). The name must be a valid key; a target property, when set, must be registered. Gated by command_type:create.

Media type application/json
object
$schema

A URL to the JSON Schema for this object.

string format: uri
description

What the command does

string
display_name

A human label

string
name
required

The command type name (lowercase, dot-hierarchied)

string
>= 1 characters
params_schema

A JSON Schema fragment for the params

settle_window_seconds

The actuation window in seconds (0 = fire-and-forget)

integer format: int64
target_property_type

The property this command sets, for settlement

string

Created

Media type application/json
object
$schema

A URL to the JSON Schema for this object.

string format: uri
description
string
display_name
string
id
required

The command type’s uuid, the stable form of name

string
name
required
string
official
required
boolean
params_schema

A JSON Schema fragment for the invocation params

settle_window_seconds
required

How long the device is given to actuate before a mismatch is a failed command

integer format: int64
target_property_type

The property this command sets (empty for a fire-and-forget command)

string
Example
{
"$schema": "/api/v1/schemas/CommandTypeBody.json"
}

Error

Media type application/problem+json
object
$schema

A URL to the JSON Schema for this object.

string format: uri
detail

A human-readable explanation specific to this occurrence of the problem.

string
errors

Optional list of individual error details

Array<object> | null
object
location

Where the error occurred, e.g. ‘body.items[3].tags’ or ‘path.thing-id’

string
message

Error message text

string
value

The value at the given location

instance

A URI reference that identifies the specific occurrence of the problem.

string format: uri
status

HTTP status code

integer format: int64
title

A short, human-readable summary of the problem type. This value should not change between occurrences of the error.

string
type

A URI reference to human-readable documentation for the error.

string format: uri
default: about:blank
Example
{
"$schema": "/api/v1/schemas/ErrorModel.json",
"detail": "Property foo is required but is missing.",
"instance": "https://example.com/error-log/abc123",
"status": 400,
"title": "Bad Request",
"type": "about:blank"
}